#ifndef PTFPS_EXPR_H
#define PTFPS_EXPR_H

#include "ptfps_process.h"

typedef struct expression {
    enum conj {CONJ_NONE, CONJ_AND, CONJ_OR} conj;
    int negated;
    char * type;
    void * term_value;
    struct expression *left, *right;
    int printed_header;
} expression_t;

extern expression_t *expression_term(char * type, char *args[]);
extern expression_t *expression_conj(enum conj conj, 
                                     expression_t *l, expression_t *r);
extern void expression_destroy(expression_t *e);
extern expression_t *expression_negate(expression_t *e);
extern expression_t *expression_parse(int argc, char *argv[]);

extern int expression_evaluate(expression_t *e, process_t *p, 
                               char *buf, size_t size);

#endif /* PTFPS_EXPR_H */
