#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */
#include "ptfps.h"

/* str_match() should return 1 if there is a match, 0 otherwise */

#ifdef HAVE_POSIX_REGEX

#include <regex.h>

#ifndef DEFAULT
#define DEFAULT 0
#endif 

int str_match(char *pattern, char *input)
{
    int ret;
    regex_t preg;

    if (regcomp(&preg, pattern, 0) < 0)
        return DEFAULT;

    ret = !regexec(&preg, input, 0, NULL, 0);

    regfree(&preg);

    return ret;
}
#else
int str_match(char *pattern, char *input)
{
    return !strcmp(pattern, input);
}
#endif /* HAVE_POSIX_REGEX */

